com.smartgwt.client.widgets.plugins

## Class Applet

- java.lang.Object
- - com.google.gwt.user.client.ui.UIObject
  - - com.google.gwt.user.client.ui.Widget
    - - com.smartgwt.client.widgets.BaseWidget
      - - com.smartgwt.client.widgets.Canvas
        - - com.smartgwt.client.widgets.plugins.BrowserPlugin
          - - com.smartgwt.client.widgets.plugins.Applet

- All Implemented Interfaces:
    com.google.gwt.event.logical.shared.HasAttachHandlers, com.google.gwt.event.shared.HasHandlers, com.google.gwt.user.client.EventListener, com.google.gwt.user.client.ui.HasVisibility, com.google.gwt.user.client.ui.IsWidget, LogicalStructure, HasClickHandlers, HasDoubleClickHandlers, HasDragMoveHandlers, HasDragRepositionMoveHandlers, HasDragRepositionStartHandlers, HasDragRepositionStopHandlers, HasDragResizeMoveHandlers, HasDragResizeStartHandlers, HasDragResizeStopHandlers, HasDragStartHandlers, HasDragStopHandlers, HasDropHandlers, HasDropMoveHandlers, HasDropOutHandlers, HasDropOverHandlers, HasFocusChangedHandlers, HasHoverHandlers, HasHoverHiddenHandlers, HasKeyDownHandlers, HasKeyPressHandlers, HasMouseDownHandlers, HasMouseMoveHandlers, HasMouseOutHandlers, HasMouseOverHandlers, HasMouseStillDownHandlers, HasMouseUpHandlers, HasMouseWheelHandlers, HasMovedHandlers, HasParentMovedHandlers, HasResizedHandlers, HasRightMouseDownHandlers, HasScrolledHandlers, HasShowContextMenuHandlers, HasVisibilityChangedHandlers

      public class Applet
      extends BrowserPlugin

  Smart GWT abstraction for Applets. This class provides Java<->Smart GWT interoperability. When embedding Applets into Smart GWT-based pages, please use this wrapper class to instantiate the Applet. Doing so will provide the following benefits:

  - Drag and drop interactions on the page can target the Applet (can drop on applet).
  - When a drag interaction transits an Applet, Smart GWT will ensure that the dragTarget appears above the Applet (prevents burn-through).
  - Allows you to easily embed the Applet into Smart GWT containers such as Windows and Layouts, providing automatic masking to ensure the correct z-index order. But see notes below for limitations.

  Known issues

  - Resizing Applets can cause Firefox to lock up and require the user to terminate the process manually. The cause is currently unknown, but likely causes include applets attempting to control their own size, or to attempt to re-render on resize. More recent JVMs (1.6+) appear to make this problem less frequent. This may also simply be caused by applet code being unable to deal with certain combination sizes and crashing.
  - In Firefox, when using a JVM older than 1.6, Applets cannot be resized smaller than their originally drawn size. Doing so causes them to stick at the originally drawn size, and to overflow the boundary of any Smart GWT component they are embedded in.
  - In Firefox, Applets do not handle the z-index ordering correctly with respect to IFRAMEs or other Applets. Therefore, in Firefox you cannot layer Applets on top of each other or on top of Smart GWT components containing IFRAMEs and have them render in the correct order.
  For a general overview of applets and an applet tutorial see: http://java.sun.com/docs/books/tutorial/applet/

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.google.gwt.user.client.ui.UIObject

      `com.google.gwt.user.client.ui.UIObject.DebugIdImpl, com.google.gwt.user.client.ui.UIObject.DebugIdImplEnabled`

  - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.widgets.BaseWidget

      `config, configOnly, id, isElementSet, nativeObject, scClassName`

    - ### Fields inherited from class com.google.gwt.user.client.ui.UIObject

      `DEBUG_ID_PREFIX`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Applet()`
    `Applet(com.google.gwt.core.client.JavaScriptObject jsObj)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, Canvas defaults)` Changes the defaults for Canvas AutoChildren named `autoChildName`.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, FormItem defaults)` Changes the defaults for FormItem AutoChildren named `autoChildName`.
    `protected com.google.gwt.core.client.JavaScriptObject` | `create()`
    `java.lang.String` | `getAlt()` This text is displayed if the browser understands the tag used for the applet html element, but can't run the applet for some reason.
    `java.lang.String` | `getAltHTML()` This text is displayed if the browser does not understand the tag used for the applet html element.
    `java.lang.String` | `getArchive()` URL to the applet JAR or ZIP archive.
    `java.lang.String` | `getClassID()` This attribute is used only with useTag: "object".
    `java.lang.String` | `getCode()` A URL that points to the class of the applet.
    `java.lang.String` | `getCodeBase()` The base URL of the applet if the `code` attribute is relative
    `java.lang.Boolean` | `getExtraHTML()` Any additional HTML you want to throw into the tag that specifies the applet element.
    `com.smartgwt.logicalstructure.core.LogicalStructureObject` | `getLogicalStructure()`
    `java.lang.Boolean` | `getMayScript()` Usable only in IE: if true allows Java->JS LiveConnect (other platforms that support LiveConnect have it enabled by default and do not allow it to be disabled).
    `java.lang.String` | `getName()` Sets the 'name' attribute on the applet object.
    `java.lang.String` | `getObjectCodeBase()` This attribute is used only with useTag: "object".
    `static Applet` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `java.util.Map` | `getParams()` A map of key/value pairs to pass to the applet as parameters.
    `com.google.gwt.dom.client.Element` | `getPluginHandle()`
    `java.lang.String` | `getPluginID()`
    `java.lang.Boolean` | `getScriptable()` Usable only in IE: if true allows JS->Java LiveConnect (other platforms that support LiveConnect have it enabled by default and do not allow it to be disabled).
    `java.lang.String` | `getSrc()` A URL that points to the class of this applet.
    `java.lang.String` | `getUseTag()` Specifies the type of tag to use for the applet html.
    `void` | `setAlt(java.lang.String alt)` This text is displayed if the browser understands the tag used for the applet html element, but can't run the applet for some reason.
    `void` | `setAltHTML(java.lang.String altHTML)` This text is displayed if the browser does not understand the tag used for the applet html element.
    `void` | `setArchive(java.lang.String archive)` URL to the applet JAR or ZIP archive.
    `void` | `setClassID(java.lang.String classID)` This attribute is used only with useTag: "object".
    `void` | `setCode(java.lang.String code)` A URL that points to the class of the applet.
    `void` | `setCodeBase(java.lang.String codeBase)` The base URL of the applet if the `code` attribute is relative
    `static void` | `setDefaultProperties(Applet appletProperties)` Class level method to set the default properties of this class.
    `void` | `setExtraHTML(java.lang.Boolean extraHTML)` Any additional HTML you want to throw into the tag that specifies the applet element.
    `void` | `setJavaScriptObject(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `com.smartgwt.logicalstructure.core.LogicalStructureObject` | `setLogicalStructure(com.smartgwt.logicalstructure.widgets.plugins.AppletLogicalStructure s)`
    `void` | `setMayScript(java.lang.Boolean mayScript)` Usable only in IE: if true allows Java->JS LiveConnect (other platforms that support LiveConnect have it enabled by default and do not allow it to be disabled).
    `void` | `setName(java.lang.String name)` Sets the 'name' attribute on the applet object.
    `void` | `setObjectCodeBase(java.lang.String objectCodeBase)` This attribute is used only with useTag: "object".
    `void` | `setParams(java.util.Map params)` A map of key/value pairs to pass to the applet as parameters.
    `void` | `setPluginID(java.lang.String pluginID)` Sets the ID to be used for the <applet> or <object> DOM element generated by this component.
    `void` | `setScriptable(java.lang.Boolean scriptable)` Usable only in IE: if true allows JS->Java LiveConnect (other platforms that support LiveConnect have it enabled by default and do not allow it to be disabled).
    `void` | `setSrc(java.lang.String src)` A URL that points to the class of this applet.
    `void` | `setUseTag(java.lang.String useTag)` Specifies the type of tag to use for the applet html.

    - ### Methods inherited from class com.smartgwt.client.widgets.plugins.BrowserPlugin

      `setDefaultProperties, setLogicalStructure`

    - ### Methods inherited from class com.smartgwt.client.widgets.Canvas

      `addChild, addChild, addChild, addChild, addChild, addClickHandler, addDoubleClickHandler, addDragMoveHandler, addDragRepositionMoveHandler, addDragRepositionStartHandler, addDragRepositionStopHandler, addDragResizeMoveHandler, addDragResizeStartHandler, addDragResizeStopHandler, addDragStartHandler, addDragStopHandler, addDropHandler, addDropMoveHandler, addDropOutHandler, addDropOverHandler, addFocusChangedHandler, addHoverHandler, addHoverHiddenHandler, addKeyDownHandler, addKeyPressHandler, addMouseDownHandler, addMouseMoveHandler, addMouseOutHandler, addMouseOverHandler, addMouseStillDownHandler, addMouseUpHandler, addMouseWheelHandler, addMovedHandler, addParentMovedHandler, addPeer, addPeer, addPeer, addPeer, addResizedHandler, addRightMouseDownHandler, addScrolledHandler, addShowContextMenuHandler, addStyleName, addVisibilityChangedHandler, adjustForContent, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateHide, animateHide, animateHide, animateMove, animateMove, animateMove, animateMove, animateRect, animateRect, animateRect, animateRect, animateResize, animateResize, animateResize, animateResize, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateShow, animateShow, animateShow, asSGWTComponent, blur, bringToFront, clear, clickMaskUp, clickMaskUp, contains, contains, containsEvent, containsFocus, containsPoint, containsPoint, deparent, depeer, disable, enable, focus, focusInNextTabElement, focusInPreviousTabElement, getAbsoluteLeft, getAbsoluteTop, getAccessKey, getAnimateAcceleration, getAnimateFadeTime, getAnimateHideAcceleration, getAnimateHideTime, getAnimateMoveAcceleration, getAnimateMoveTime, getAnimateRectAcceleration, getAnimateRectTime, getAnimateResizeAcceleration, getAnimateResizeTime, getAnimateScrollAcceleration, getAnimateScrollTime, getAnimateShowAcceleration, getAnimateShowEffect, getAnimateShowTime, getAnimateTime, getAppImgDir, getAriaRole, getAutoDraw, getAutoShowParent, getBackgroundColor, getBackgroundImage, getBackgroundPosition, getBackgroundRepeat, getBorder, getBottom, getById, getByJSObject, getByLocalId, getCanAcceptDrop, getCanDrag, getCanDragReposition, getCanDragResize, getCanDragScroll, getCanDrop, getCanDropBefore, getCanFocus, getCanHover, getCanSelectText, getCanvasAutoChild, getCanvasItem, getChildren, getChildrenSnapResizeToGrid, getChildrenSnapToGrid, getClassName, getContentElement, getContents, getContextMenu, getCursor, getDataPath, getDefaultHeight, getDefaultWidth, getDestroyed, getDestroying, getDisabled, getDisabledCursor, getDoubleClickDelay, getDragAppearance, getDragIntersectStyle, getDragOpacity, getDragRepositionAppearance, getDragRepositionCursor, getDragResizeAppearance, getDragScrollDelay, getDragStartDistance, getDragTarget, getDragType, getDropTypes, getDynamicContents, getEdgeBackgroundColor, getEdgeCenterBackgroundColor, getEdgeImage, getEdgeMarginSize, getEdgeOffset, getEdgeOpacity, getEdgeShowCenter, getEdgeSize, getEventEdge, getEventEdge, getExtraSpace, getFacetId, getFormItemAutoChild, getFullDataPath, getGroupBorderCSS, getGroupLabelBackgroundColor, getGroupLabelStyleName, getGroupTitle, getHeight, getHeightAsString, getHideUsingDisplayNone, getHoverAlign, getHoverAutoDestroy, getHoverComponent, getHoverDelay, getHoverHeight, getHoverHTML, getHoverMoveWithMouse, getHoverOpacity, getHoverStyle, getHoverVAlign, getHoverWidth, getHoverWrap, getHSnapOrigin, getHSnapOrigin, getHSnapPosition, getHSnapPosition, getHtmlPosition, getImage, getImgURL, getImgURL, getInnerContentHeight, getInnerContentWidth, getInnerHeight, getInnerWidth, getIsGroup, getKeepInParentRect, getLayoutAlign, getLeft, getLeftAsString, getLocateChildrenBy, getLocateChildrenType, getLocatePeersBy, getLocatePeersType, getMargin, getMasterElement, getMatchElement, getMaxHeight, getMaxWidth, getMenuConstructor, getMinHeight, getMinWidth, getMouseStillDownDelay, getMouseStillDownInitialDelay, getNextZIndex, getNoDoubleClicks, getOffsetHeight, getOffsetWidth, getOffsetX, getOffsetY, getOpacity, getOuterElement, getOverflow, getPadding, getPageBottom, getPageLeft, getPageRect, getPageRight, getPageTop, getParentElement, getPeers, getPercentBox, getPercentSource, getPosition, getPrefix, getPrintChildrenAbsolutelyPositioned, getPrintHTML, getPrintHTML, getPrompt, getRect, getRedrawOnResize, getResizeBarTarget, getResizeFrom, getRight, getScrollbarSize, getScrollBottom, getScrollHeight, getScrollLeft, getScrollRight, getScrollTop, getScrollWidth, getShadowDepth, getShadowImage, getShadowOffset, getShadowSoftness, getShouldPrint, getShowCustomScrollbars, getShowDragShadow, getShowEdges, getShowHover, getShowHoverComponents, getShowResizeBar, getShowShadow, getSkinImgDir, getSnapAxis, getSnapEdge, getSnapHDirection, getSnapHGap, getSnapOffsetLeft, getSnapOffsetTop, getSnapOnDrop, getSnapResizeToGrid, getSnapTo, getSnapToGrid, getSnapVDirection, getSnapVGap, getStyleName, getTabIndex, getTestInstance, getTitle, getTooltip, getTop, getTopAsString, getTopElement, getUseBackMask, getUseOpacityFilter, getValuesManager, getViewportHeight, getViewportWidth, getVisibility, getVisibleHeight, getVisibleWidth, getVSnapOrigin, getVSnapOrigin, getVSnapPosition, getVSnapPosition, getWidth, getWidthAsString, getZIndex, handleHover, hide, hideClickMask, hideClickMask, hideContextMenu, imgHTML, imgHTML, imgHTML, intersects, isDirty, isDisabled, isDrawn, isVisible, keyUp, layoutChildren, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, markForDestroy, markForRedraw, markForRedraw, moveAbove, moveBelow, moveBy, moveTo, onAttach, onDetach, onInit, parentResized, printComponents, redraw, redraw, removeChild, removeChild, removePeer, removePeer, resizeBy, resizeTo, resizeTo, scrollBy, scrollByPercent, scrollTo, scrollTo, scrollTo, scrollToBottom, scrollToLeft, scrollToPercent, scrollToRight, scrollToTop, sendToBack, setAccessKey, setAlign, setAllowExternalFilters, setAnimateAcceleration, setAnimateFadeTime, setAnimateHideAcceleration, setAnimateHideTime, setAnimateMoveAcceleration, setAnimateMoveTime, setAnimateRectAcceleration, setAnimateRectTime, setAnimateResizeAcceleration, setAnimateResizeTime, setAnimateScrollAcceleration, setAnimateScrollTime, setAnimateShowAcceleration, setAnimateShowEffect, setAnimateShowTime, setAnimateTime, setAppImgDir, setAriaRole, setAriaState, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setAutoDraw, setAutoHeight, setAutoShowParent, setAutoWidth, setBackgroundColor, setBackgroundImage, setBackgroundPosition, setBackgroundRepeat, setBorder, setBottom, setCanAcceptDrop, setCanDrag, setCanDragReposition, setCanDragResize, setCanDragScroll, setCanDrop, setCanDropBefore, setCanFocus, setCanHover, setCanSelectText, setCanvasItem, setChildren, setChildrenSnapResizeToGrid, setChildrenSnapToGrid, setContents, setContextMenu, setCursor, setDataPath, setDefaultHeight, setDefaultProperties, setDefaultWidth, setDisabled, setDisabledCursor, setDoubleClickDelay, setDragAppearance, setDragIntersectStyle, setDragOpacity, setDragRepositionAppearance, setDragRepositionCursor, setDragResizeAppearance, setDragScrollDelay, setDragStartDistance, setDragTarget, setDragType, setDropTypes, setDynamicContents, setEdgeBackgroundColor, setEdgeCenterBackgroundColor, setEdgeImage, setEdgeMarginSize, setEdgeOffset, setEdgeOpacity, setEdgeShowCenter, setEdgeSize, setExtraSpace, setFacetId, setGroupBorderCSS, setGroupLabelBackgroundColor, setGroupLabelStyleName, setGroupTitle, setHeight, setHeight, setHeight100, setHideUsingDisplayNone, setHoverAlign, setHoverAutoDestroy, setHoverDelay, setHoverHeight, setHoverMoveWithMouse, setHoverOpacity, setHoverStyle, setHoverVAlign, setHoverWidth, setHoverWrap, setHtmlPosition, setImage, setImage, setIsGroup, setKeepInParentRect, setKeepInParentRect, setKeepInParentRect, setLayoutAlign, setLayoutAlign, setLeft, setLeft, setLocateChildrenBy, setLocateChildrenType, setLocatePeersBy, setLocatePeersType, setLogicalStructure, setMargin, setMatchElement, setMaxHeight, setMaxWidth, setMenuConstructor, setMinHeight, setMinWidth, setMouseStillDownDelay, setMouseStillDownInitialDelay, setNeverUseFilters, setNoDoubleClicks, setOpacity, setOverflow, setPadding, setPageLeft, setPageTop, setParentElement, setPeers, setPercentBox, setPercentSource, setPosition, setPrefix, setPrintChildrenAbsolutelyPositioned, setPrompt, setRect, setRect, setRedrawOnResize, setResizeBarTarget, setResizeFrom, setResizeFrom, setRight, setScrollbarConstructor, setScrollbarSize, setShadowDepth, setShadowImage, setShadowOffset, setShadowSoftness, setShouldPrint, setShowCustomScrollbars, setShowDragShadow, setShowEdges, setShowHover, setShowHoverComponents, setShowResizeBar, setShowShadow, setSkinImgDir, setSmoothFade, setSnapAxis, setSnapEdge, setSnapHDirection, setSnapHGap, setSnapOffsetLeft, setSnapOffsetTop, setSnapOnDrop, setSnapResizeToGrid, setSnapTo, setSnapToGrid, setSnapVDirection, setSnapVGap, setStyleName, setTabIndex, setTitle, setTooltip, setTop, setTop, setUseBackMask, setUseOpacityFilter, setValuesManager, setVisibility, setVisible, setWidth, setWidth, setWidth100, setZIndex, shouldDragScroll, show, showClickMask, showNextTo, showNextTo, showNextTo, showNextTo, showPrintPreview, showPrintPreview, showPrintPreview, showPrintPreview, showRecursively, updateHover, updateHover, updateShadow, visibleAtPoint, willAcceptDrop`

    - ### Methods inherited from class com.smartgwt.client.widgets.BaseWidget

      `addDrawHandler, destroy, doAddHandler, doInit, doOnRender, draw, equals, error, errorIfNotCreated, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDateArray, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsFloatArray, getAttributeAsInt, getAttributeAsIntArray, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsRecord, getAttributeAsString, getAttributeAsStringArray, getConfig, getDOM, getElement, getElement, getHandlerCount, getID, getInnerHTML, getJsObj, getOrCreateJsObj, getRef, getScClassName, hashCode, initNativeObject, internalSetID, internalSetID, isConfigOnly, isCreated, onBind, onDestroy, onDraw, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setConfig, setConfigOnly, setDragTracker, setElement, setHtmlElement, setID, setLogicalStructure, setNullProperty, setPosition, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setScClassName, toString`

    - ### Methods inherited from class com.google.gwt.user.client.ui.Widget

      `addAttachHandler, addBitlessDomHandler, addDomHandler, addHandler, asWidget, asWidgetOrNull, createHandlerManager, delegateEvent, doAttachChildren, doDetachChildren, fireEvent, getLayoutData, getParent, isAttached, isOrWasAttached, onBrowserEvent, onLoad, onUnload, removeFromParent, setLayoutData, sinkEvents`

    - ### Methods inherited from class com.google.gwt.user.client.ui.UIObject

      `addStyleDependentName, ensureDebugId, ensureDebugId, ensureDebugId, getStyleElement, getStyleName, getStylePrimaryName, getStylePrimaryName, isVisible, onEnsureDebugId, removeStyleDependentName, removeStyleName, resolvePotentialElement, setElement, setPixelSize, setSize, setStyleDependentName, setStyleName, setStyleName, setStyleName, setStylePrimaryName, setStylePrimaryName, setVisible, sinkBitlessEvent, unsinkEvents`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

      `fireEvent`

- - ### Constructor Detail

    - #### Applet

          public Applet()

    - #### Applet

          public Applet(com.google.gwt.core.client.JavaScriptObject jsObj)

  - ### Method Detail

    - #### getOrCreateRef

          public static Applet getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### setJavaScriptObject

          public void setJavaScriptObject(com.google.gwt.core.client.JavaScriptObject jsObj)

      Overrides:
        `setJavaScriptObject` in class `BrowserPlugin`

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                     Canvas defaults)

      Changes the defaults for Canvas AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties.
      See Also:
        `AutoChildUsage`

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                     FormItem defaults)

      Changes the defaults for FormItem AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties.
      See Also:
        `AutoChildUsage`

    - #### create

          protected com.google.gwt.core.client.JavaScriptObject create()

      Overrides:
        `create` in class `BrowserPlugin`

    - #### setAlt

          public void setAlt(java.lang.String alt)
                      throws java.lang.IllegalStateException

      This text is displayed if the browser understands the tag used for the applet html element, but can't run the applet for some reason.
      Parameters:
        `alt` - . See `String`. Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `setAltHTML(java.lang.String)`, `setUseTag(java.lang.String)`

    - #### getAlt

          public java.lang.String getAlt()

      This text is displayed if the browser understands the tag used for the applet html element, but can't run the applet for some reason.
      Returns:
        . See `String`
      See Also:
        `getAltHTML()`, `getUseTag()`

    - #### setAltHTML

          public void setAltHTML(java.lang.String altHTML)
                          throws java.lang.IllegalStateException

      This text is displayed if the browser does not understand the tag used for the applet html element.
      Parameters:
        `altHTML` - . See `String`. Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `setAlt(java.lang.String)`, `setUseTag(java.lang.String)`

    - #### getAltHTML

          public java.lang.String getAltHTML()

      This text is displayed if the browser does not understand the tag used for the applet html element.
      Returns:
        . See `String`
      See Also:
        `getAlt()`, `getUseTag()`

    - #### setArchive

          public void setArchive(java.lang.String archive)
                          throws java.lang.IllegalStateException

      URL to the applet JAR or ZIP archive.
      Parameters:
        `archive` - . See `String`. Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `setCode(java.lang.String)`, `setCodeBase(java.lang.String)`

    - #### getArchive

          public java.lang.String getArchive()

      URL to the applet JAR or ZIP archive.
      Returns:
        . See `String`
      See Also:
        `getCode()`, `getCodeBase()`

    - #### setClassID

          public void setClassID(java.lang.String classID)
                          throws java.lang.IllegalStateException

      This attribute is used only with useTag: "object". In combination with `objectCodeBase` this tag specifies the minimum JVM version required to view this applet and the URL from which the JVM can be downloaded.

      The default settings match the default behavior of the <applet> tag which requires JVM 1.3 or higher.

      The default classID is: "clsid:8AD9C840-044E-11D1-B3E9-00805F499D93"

      For notes on this feature see: http://java.sun.com/j2se/1.4.2/docs/guide/plugin/developer_guide/using_tags.html#in-ie

      Parameters:
        `classID` - . See `String`. Default value is see below
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `setObjectCodeBase(java.lang.String)`

    - #### getClassID

          public java.lang.String getClassID()

      This attribute is used only with useTag: "object". In combination with `objectCodeBase` this tag specifies the minimum JVM version required to view this applet and the URL from which the JVM can be downloaded.

      The default settings match the default behavior of the <applet> tag which requires JVM 1.3 or higher.

      The default classID is: "clsid:8AD9C840-044E-11D1-B3E9-00805F499D93"

      For notes on this feature see: http://java.sun.com/j2se/1.4.2/docs/guide/plugin/developer_guide/using_tags.html#in-ie

      Returns:
        . See `String`
      See Also:
        `getObjectCodeBase()`

    - #### setCode

          public void setCode(java.lang.String code)
                       throws java.lang.IllegalStateException

      A URL that points to the class of the applet.
      Parameters:
        `code` - . See `String`. Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `setCodeBase(java.lang.String)`, `setArchive(java.lang.String)`

    - #### getCode

          public java.lang.String getCode()

      A URL that points to the class of the applet.
      Returns:
        . See `String`
      See Also:
        `getCodeBase()`, `getArchive()`

    - #### setCodeBase

          public void setCodeBase(java.lang.String codeBase)
                           throws java.lang.IllegalStateException

      The base URL of the applet if the `code` attribute is relative
      Parameters:
        `codeBase` - . See `String`. Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `setCode(java.lang.String)`, `setArchive(java.lang.String)`

    - #### getCodeBase

          public java.lang.String getCodeBase()

      The base URL of the applet if the `code` attribute is relative
      Returns:
        . See `String`
      See Also:
        `getCode()`, `getArchive()`

    - #### setExtraHTML

          public void setExtraHTML(java.lang.Boolean extraHTML)
                            throws java.lang.IllegalStateException

      Any additional HTML you want to throw into the tag that specifies the applet element.
      Parameters:
        `extraHTML` - extraHTML Default value is true
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getExtraHTML

          public java.lang.Boolean getExtraHTML()

      Any additional HTML you want to throw into the tag that specifies the applet element.
      Returns:
        Boolean

    - #### setMayScript

          public void setMayScript(java.lang.Boolean mayScript)
                            throws java.lang.IllegalStateException

      Usable only in IE: if true allows Java->JS LiveConnect (other platforms that support LiveConnect have it enabled by default and do not allow it to be disabled).
      Parameters:
        `mayScript` - mayScript Default value is true
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `setScriptable(java.lang.Boolean)`

    - #### getMayScript

          public java.lang.Boolean getMayScript()

      Usable only in IE: if true allows Java->JS LiveConnect (other platforms that support LiveConnect have it enabled by default and do not allow it to be disabled).
      Returns:
        Boolean
      See Also:
        `getScriptable()`

    - #### setName

          public void setName(java.lang.String name)
                       throws java.lang.IllegalStateException

      Sets the 'name' attribute on the applet object. If a name is not provided it will be auto-generated. Note that in general you don't need to set this. If you have a handle to your ISC Applet object you can simply call `Applet.getPluginHandle` to get a handle to the element.
      Parameters:
        `name` - . See `String`. Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `getPluginHandle()`

    - #### getName

          public java.lang.String getName()

      Sets the 'name' attribute on the applet object. If a name is not provided it will be auto-generated. Note that in general you don't need to set this. If you have a handle to your ISC Applet object you can simply call `Applet.getPluginHandle` to get a handle to the element.
      Returns:
        . See `String`
      See Also:
        `getPluginHandle()`

    - #### setObjectCodeBase

          public void setObjectCodeBase(java.lang.String objectCodeBase)
                                 throws java.lang.IllegalStateException

      This attribute is used only with useTag: "object". In combination with `classID` this tag specifies the minimum JVM version required to view this applet and the URL from which the JVM can be downloaded.

      The default settings match the default behavior of the <applet> tag which requires JVM 1.3 or higher.

      The default objectCodeBase is: "http://java.sun.com/products/plugin/1.3/jinstall-13-win32.cab#Version=1,3,0,0"

      For notes on this feature see: http://java.sun.com/j2se/1.4.2/docs/guide/plugin/developer_guide/using_tags.html#in-ie

      Parameters:
        `objectCodeBase` - . See `String`. Default value is see below
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `setClassID(java.lang.String)`

    - #### getObjectCodeBase

          public java.lang.String getObjectCodeBase()

      This attribute is used only with useTag: "object". In combination with `classID` this tag specifies the minimum JVM version required to view this applet and the URL from which the JVM can be downloaded.

      The default settings match the default behavior of the <applet> tag which requires JVM 1.3 or higher.

      The default objectCodeBase is: "http://java.sun.com/products/plugin/1.3/jinstall-13-win32.cab#Version=1,3,0,0"

      For notes on this feature see: http://java.sun.com/j2se/1.4.2/docs/guide/plugin/developer_guide/using_tags.html#in-ie

      Returns:
        . See `String`
      See Also:
        `getClassID()`

    - #### setScriptable

          public void setScriptable(java.lang.Boolean scriptable)
                             throws java.lang.IllegalStateException

      Usable only in IE: if true allows JS->Java LiveConnect (other platforms that support LiveConnect have it enabled by default and do not allow it to be disabled).
      Parameters:
        `scriptable` - scriptable Default value is true
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `setMayScript(java.lang.Boolean)`

    - #### getScriptable

          public java.lang.Boolean getScriptable()

      Usable only in IE: if true allows JS->Java LiveConnect (other platforms that support LiveConnect have it enabled by default and do not allow it to be disabled).
      Returns:
        Boolean
      See Also:
        `getMayScript()`

    - #### setSrc

          public void setSrc(java.lang.String src)
                      throws java.lang.IllegalStateException

      A URL that points to the class of this applet. This is the same as the 'code' attribute. Note that if you specify both the src and the code attributes, the src attribute will be ignored in favor of the code attribute.
      Parameters:
        `src` - . See `String`. Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getSrc

          public java.lang.String getSrc()

      A URL that points to the class of this applet. This is the same as the 'code' attribute. Note that if you specify both the src and the code attributes, the src attribute will be ignored in favor of the code attribute.
      Returns:
        . See `String`

    - #### setUseTag

          public void setUseTag(java.lang.String useTag)
                         throws java.lang.IllegalStateException

      Specifies the type of tag to use for the applet html. See http://java.sun.com/j2se/1.4.2/docs/guide/plugin/developer_guide/using_tags.html for a discussion of different tags.
      Parameters:
        `useTag` - . See `String`. Default value is "applet"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getUseTag

          public java.lang.String getUseTag()

      Specifies the type of tag to use for the applet html. See http://java.sun.com/j2se/1.4.2/docs/guide/plugin/developer_guide/using_tags.html for a discussion of different tags.
      Returns:
        . See `String`

    - #### getPluginHandle

          public com.google.gwt.dom.client.Element getPluginHandle()

      Returns:
        Returns a handle to the applet DOM element (valid only after the component has been drawn).

    - #### getPluginID

          public java.lang.String getPluginID()

      Returns:
        ID used for the <applet> or <object> DOM element generated by this component.

    - #### setPluginID

          public void setPluginID(java.lang.String pluginID)

      Sets the ID to be used for the <applet> or <object> DOM element generated by this component. Can only be set before draw.
      Parameters:
        `pluginID` -

    - #### setDefaultProperties

          public static void setDefaultProperties(Applet appletProperties)

      Class level method to set the default properties of this class. If set, then all subsequent instances of this class will automatically have the default properties that were set when this method was called. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

      Note: This method is intended for setting default attributes only and will effect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead.

      Parameters:
        `appletProperties` - properties that should be used as new defaults when instances of this class are created

    - #### setParams

          public void setParams(java.util.Map params)
                         throws java.lang.IllegalStateException

      A map of key/value pairs to pass to the applet as parameters. These are typically accessible within the Java applet code.
      Parameters:
        `params` - Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getParams

          public java.util.Map getParams()

      A map of key/value pairs to pass to the applet as parameters. These are typically accessible within the Java applet code.
      Returns:
        params for this applet

    - #### setLogicalStructure

          public com.smartgwt.logicalstructure.core.LogicalStructureObject setLogicalStructure(com.smartgwt.logicalstructure.widgets.plugins.AppletLogicalStructure s)

    - #### getLogicalStructure

          public com.smartgwt.logicalstructure.core.LogicalStructureObject getLogicalStructure()

      Specified by:
        `getLogicalStructure` in interface `LogicalStructure`
      Overrides:
        `getLogicalStructure` in class `BrowserPlugin`